/*
 * $Id: state.hpp 149 2007-11-08 23:43:53Z hangman $
 *
 * What We Are
 *
 * Copyright (C) 1994 - 2007 Enver Haase
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */



#ifndef STATE_HPP
#define STATE_HPP


//
// Includes
//

#include "exceptions.hpp"



//
// Classes
//

/* This abstract class represents a state the
 * application can be in.
 */
class state
{
public:
	state(void);
	virtual ~state(void);

	virtual void enterState(void) throw (GameException) = 0;
   	virtual void update(void)     throw (GameException) = 0;
	virtual void exitState(void)  = 0;
};



#endif
